--------------------------------------
-- Question 1				--
-- Trace d'excution du bloc PL/SQL --
--------------------------------------
SQL> start tp8a

Table dropped.

Table created.

----------------------------------
-- Insertion d'un tuple correct --
----------------------------------
'Entrez le numro du segment :'
130.120.82
'Entrez le numro du logiciel :'
log8
'Entrez le nom du logiciel :'
Windows2000
'Entrez la date d''achat du logiciel :'
15-MAY-1998
'Entrez la version du logiciel :'
1.00
'Entrez le type du logiciel :'
PCWS
old   5: 	WHERE POSTE.N_SEGMENT = '&NumSegment'
new   5: 	WHERE POSTE.N_SEGMENT = '130.120.82'
old   6: 	AND TYPE_P = '&TypeLogiciel'
new   6: 	AND TYPE_P = 'PCWS'
old  23: 	WHERE N_SEGMENT='&NumSegment';
new  23: 	WHERE N_SEGMENT='130.120.82';
old  25: 	IF TO_DATE('&DateAchatLogiciel') > TO_DATE(SYSDATE) THEN
new  25: 	IF TO_DATE('15-MAY-1998') > TO_DATE(SYSDATE) THEN
old  30:  	('&NumLogiciel','&NomLogiciel','&DateAchatLogiciel','&VersionLogiciel','&TypeLogiciel',0);
new  30:  	('log8','Windows2000','15-MAY-1998','1.00','PCWS',0);
old  32: 	MESSAGE := 'Enregistrement du logiciel &NomLogiciel dans LOGICIEL';
new  32: 	MESSAGE := 'Enregistrement du logiciel Windows2000 dans LOGICIEL';
old  36: 	WHERE N_SEGMENT='&NumSegment'
new  36: 	WHERE N_SEGMENT='130.120.82'
old  37: 	AND TYPE_P='&TypeLogiciel';
new  37: 	AND TYPE_P='PCWS';
old  46: 		(CURSEURPOSTE_REC.N_POSTE,'&NumLogiciel',SYSDATE);
new  46: 		(CURSEURPOSTE_REC.N_POSTE,'log8',SYSDATE);
old  49: 		UPDATE LOGICIEL SET NB_INSTALL = NB_INSTALL + 1 WHERE '&NumLogiciel' = N_LOG;
new  49: 		UPDATE LOGICIEL SET NB_INSTALL = NB_INSTALL + 1 WHERE 'log8' = N_LOG;
old  62: 		INSERT INTO COMPTE_RENDU VALUES ('Le &NumLogiciel est deja prsent dans LOGICIEL.');
new  62: 		INSERT INTO COMPTE_RENDU VALUES ('Le log8 est deja prsent dans LOGICIEL.');

PL/SQL procedure successfully completed.

No errors.

LIGNE_COMPTE_RENDU                                                              
--------------------------------------------------------------------------------
Enregistrement du logiciel Windows2000 dans LOGICIEL                            
Installation sur le Poste 12 dans la salle Salle 21                             
Transaction reussie !                                                           


---------------------------------------
-- Tentative d'insertion d'un tuple  --
-- avec un NUMERO DE SEGMENT INCONNU --
---------------------------------------
Table dropped.

Table created.

'Entrez le numro du segment :'
130.120.85
'Entrez le numro du logiciel :'
log9
'Entrez le nom du logiciel :'
Rose98
'Entrez la date d''achat du logiciel :'
15-MAY-1998
'Entrez la version du logiciel :'
1.00
'Entrez le type du logiciel :'
PCWS
old   5: 	WHERE POSTE.N_SEGMENT = '&NumSegment'
new   5: 	WHERE POSTE.N_SEGMENT = '130.120.85'
old   6: 	AND TYPE_P = '&TypeLogiciel'
new   6: 	AND TYPE_P = 'PCWS'
old  23: 	WHERE N_SEGMENT='&NumSegment';
new  23: 	WHERE N_SEGMENT='130.120.85';
old  25: 	IF TO_DATE('&DateAchatLogiciel') > TO_DATE(SYSDATE) THEN
new  25: 	IF TO_DATE('15-MAY-1998') > TO_DATE(SYSDATE) THEN
old  30:  	('&NumLogiciel','&NomLogiciel','&DateAchatLogiciel','&VersionLogiciel','&TypeLogiciel',0);
new  30:  	('log9','Rose98','15-MAY-1998','1.00','PCWS',0);
old  32: 	MESSAGE := 'Enregistrement du logiciel &NomLogiciel dans LOGICIEL';
new  32: 	MESSAGE := 'Enregistrement du logiciel Rose98 dans LOGICIEL';
old  36: 	WHERE N_SEGMENT='&NumSegment'
new  36: 	WHERE N_SEGMENT='130.120.85'
old  37: 	AND TYPE_P='&TypeLogiciel';
new  37: 	AND TYPE_P='PCWS';
old  46: 		(CURSEURPOSTE_REC.N_POSTE,'&NumLogiciel',SYSDATE);
new  46: 		(CURSEURPOSTE_REC.N_POSTE,'log9',SYSDATE);
old  49: 		UPDATE LOGICIEL SET NB_INSTALL = NB_INSTALL + 1 WHERE '&NumLogiciel' = N_LOG;
new  49: 		UPDATE LOGICIEL SET NB_INSTALL = NB_INSTALL + 1 WHERE 'log9' = N_LOG;
old  62: 		INSERT INTO COMPTE_RENDU VALUES ('Le &NumLogiciel est deja prsent dans LOGICIEL.');
new  62: 		INSERT INTO COMPTE_RENDU VALUES ('Le log9 est deja prsent dans LOGICIEL.');

PL/SQL procedure successfully completed.

No errors.

LIGNE_COMPTE_RENDU                                                              
--------------------------------------------------------------------------------
Numero de segment inconnu.                                                      

---------------------------------------------
-- Tentative d'insertion d'un tuple        --
-- avec un NUMERO DE LOGICIEL DEJA PRESENT --
---------------------------------------------
Table dropped.

Table created.

'Entrez le numro du segment :'
130.120.82
'Entrez le numro du logiciel :'
log8
'Entrez le nom du logiciel :'
Rose98
'Entrez la date d''achat du logiciel :'
15-MAY-1998
'Entrez la version du logiciel :'
2.00
'Entrez le type du logiciel :'
PCWS
old   5: 	WHERE POSTE.N_SEGMENT = '&NumSegment'
new   5: 	WHERE POSTE.N_SEGMENT = '130.120.82'
old   6: 	AND TYPE_P = '&TypeLogiciel'
new   6: 	AND TYPE_P = 'PCWS'
old  23: 	WHERE N_SEGMENT='&NumSegment';
new  23: 	WHERE N_SEGMENT='130.120.82';
old  25: 	IF TO_DATE('&DateAchatLogiciel') > TO_DATE(SYSDATE) THEN
new  25: 	IF TO_DATE('15-MAY-1998') > TO_DATE(SYSDATE) THEN
old  30:  	('&NumLogiciel','&NomLogiciel','&DateAchatLogiciel','&VersionLogiciel','&TypeLogiciel',0);
new  30:  	('log8','Rose98','15-MAY-1998','2.00','PCWS',0);
old  32: 	MESSAGE := 'Enregistrement du logiciel &NomLogiciel dans LOGICIEL';
new  32: 	MESSAGE := 'Enregistrement du logiciel Rose98 dans LOGICIEL';
old  36: 	WHERE N_SEGMENT='&NumSegment'
new  36: 	WHERE N_SEGMENT='130.120.82'
old  37: 	AND TYPE_P='&TypeLogiciel';
new  37: 	AND TYPE_P='PCWS';
old  46: 		(CURSEURPOSTE_REC.N_POSTE,'&NumLogiciel',SYSDATE);
new  46: 		(CURSEURPOSTE_REC.N_POSTE,'log8',SYSDATE);
old  49: 		UPDATE LOGICIEL SET NB_INSTALL = NB_INSTALL + 1 WHERE '&NumLogiciel' = N_LOG;
new  49: 		UPDATE LOGICIEL SET NB_INSTALL = NB_INSTALL + 1 WHERE 'log8' = N_LOG;
old  62: 		INSERT INTO COMPTE_RENDU VALUES ('Le &NumLogiciel est deja prsent dans LOGICIEL.');
new  62: 		INSERT INTO COMPTE_RENDU VALUES ('Le log8 est deja prsent dans LOGICIEL.');

PL/SQL procedure successfully completed.

No errors.

LIGNE_COMPTE_RENDU                                                              
--------------------------------------------------------------------------------
Le log8 est deja prsent dans LOGICIEL.                                         

---------------------------------------
-- Tentative d'insertion d'un tuple  --
-- avec un TYPE DE LOGICIEL INCONNU  --
---------------------------------------
Table dropped.

Table created.

'Entrez le numro du segment :'
130.120.82
'Entrez le numro du logiciel :'
log10
'Entrez le nom du logiciel :'
Rose98
'Entrez la date d''achat du logiciel :'
15-MAY-1998
'Entrez la version du logiciel :'
1.00
'Entrez le type du logiciel :'
LINUX
old   5: 	WHERE POSTE.N_SEGMENT = '&NumSegment'
new   5: 	WHERE POSTE.N_SEGMENT = '130.120.82'
old   6: 	AND TYPE_P = '&TypeLogiciel'
new   6: 	AND TYPE_P = 'LINUX'
old  23: 	WHERE N_SEGMENT='&NumSegment';
new  23: 	WHERE N_SEGMENT='130.120.82';
old  25: 	IF TO_DATE('&DateAchatLogiciel') > TO_DATE(SYSDATE) THEN
new  25: 	IF TO_DATE('15-MAY-1998') > TO_DATE(SYSDATE) THEN
old  30:  	('&NumLogiciel','&NomLogiciel','&DateAchatLogiciel','&VersionLogiciel','&TypeLogiciel',0);
new  30:  	('log10','Rose98','15-MAY-1998','1.00','LINUX',0);
old  32: 	MESSAGE := 'Enregistrement du logiciel &NomLogiciel dans LOGICIEL';
new  32: 	MESSAGE := 'Enregistrement du logiciel Rose98 dans LOGICIEL';
old  36: 	WHERE N_SEGMENT='&NumSegment'
new  36: 	WHERE N_SEGMENT='130.120.82'
old  37: 	AND TYPE_P='&TypeLogiciel';
new  37: 	AND TYPE_P='LINUX';
old  46: 		(CURSEURPOSTE_REC.N_POSTE,'&NumLogiciel',SYSDATE);
new  46: 		(CURSEURPOSTE_REC.N_POSTE,'log10',SYSDATE);
old  49: 		UPDATE LOGICIEL SET NB_INSTALL = NB_INSTALL + 1 WHERE '&NumLogiciel' = N_LOG;
new  49: 		UPDATE LOGICIEL SET NB_INSTALL = NB_INSTALL + 1 WHERE 'log10' = N_LOG;
old  62: 		INSERT INTO COMPTE_RENDU VALUES ('Le &NumLogiciel est deja prsent dans LOGICIEL.');
new  62: 		INSERT INTO COMPTE_RENDU VALUES ('Le log10 est deja prsent dans LOGICIEL.');

PL/SQL procedure successfully completed.

No errors.

LIGNE_COMPTE_RENDU                                                              
--------------------------------------------------------------------------------
Type de logiciel inconnu.                                                       

---------------------------------------
-- Tentative d'insertion d'un tuple  --
-- avec une DATE D'ACHAT ERRONEE     --
---------------------------------------
Table dropped.

Table created.

'Entrez le numro du segment :'
130.120.82
'Entrez le numro du logiciel :'
log10
'Entrez le nom du logiciel :'
Rose98
'Entrez la date d''achat du logiciel :'
15-MAY-2001
'Entrez la version du logiciel :'
1.00
'Entrez le type du logiciel :'
PCWS
old   5: 	WHERE POSTE.N_SEGMENT = '&NumSegment'
new   5: 	WHERE POSTE.N_SEGMENT = '130.120.82'
old   6: 	AND TYPE_P = '&TypeLogiciel'
new   6: 	AND TYPE_P = 'PCWS'
old  23: 	WHERE N_SEGMENT='&NumSegment';
new  23: 	WHERE N_SEGMENT='130.120.82';
old  25: 	IF TO_DATE('&DateAchatLogiciel') > TO_DATE(SYSDATE) THEN
new  25: 	IF TO_DATE('15-MAY-2001') > TO_DATE(SYSDATE) THEN
old  30:  	('&NumLogiciel','&NomLogiciel','&DateAchatLogiciel','&VersionLogiciel','&TypeLogiciel',0);
new  30:  	('log10','Rose98','15-MAY-2001','1.00','PCWS',0);
old  32: 	MESSAGE := 'Enregistrement du logiciel &NomLogiciel dans LOGICIEL';
new  32: 	MESSAGE := 'Enregistrement du logiciel Rose98 dans LOGICIEL';
old  36: 	WHERE N_SEGMENT='&NumSegment'
new  36: 	WHERE N_SEGMENT='130.120.82'
old  37: 	AND TYPE_P='&TypeLogiciel';
new  37: 	AND TYPE_P='PCWS';
old  46: 		(CURSEURPOSTE_REC.N_POSTE,'&NumLogiciel',SYSDATE);
new  46: 		(CURSEURPOSTE_REC.N_POSTE,'log10',SYSDATE);
old  49: 		UPDATE LOGICIEL SET NB_INSTALL = NB_INSTALL + 1 WHERE '&NumLogiciel' = N_LOG;
new  49: 		UPDATE LOGICIEL SET NB_INSTALL = NB_INSTALL + 1 WHERE 'log10' = N_LOG;
old  62: 		INSERT INTO COMPTE_RENDU VALUES ('Le &NumLogiciel est deja prsent dans LOGICIEL.');
new  62: 		INSERT INTO COMPTE_RENDU VALUES ('Le log10 est deja prsent dans LOGICIEL.');

PL/SQL procedure successfully completed.

No errors.

LIGNE_COMPTE_RENDU                                                              
--------------------------------------------------------------------------------
Date d'achat du logiciel superieure a la date du jour.                          

-------------------------------------------------------
--         Tentative d'insertion d'un tuple           --
-- avec un TYPE DE POSTE INCOMPATIBLE AVEC LE SEGMENT --
-------------------------------------------------------
Table dropped.

Table created.

'Entrez le numro du segment :'
130.120.82
'Entrez le numro du logiciel :'
log10
'Entrez le nom du logiciel :'
Rose98
'Entrez la date d''achat du logiciel :'
15-MAY-1997
'Entrez la version du logiciel :'
1.00
'Entrez le type du logiciel :'
TX
old   5: 	WHERE POSTE.N_SEGMENT = '&NumSegment'
new   5: 	WHERE POSTE.N_SEGMENT = '130.120.82'
old   6: 	AND TYPE_P = '&TypeLogiciel'
new   6: 	AND TYPE_P = 'TX'
old  23: 	WHERE N_SEGMENT='&NumSegment';
new  23: 	WHERE N_SEGMENT='130.120.82';
old  25: 	IF TO_DATE('&DateAchatLogiciel') > TO_DATE(SYSDATE) THEN
new  25: 	IF TO_DATE('15-MAY-1997') > TO_DATE(SYSDATE) THEN
old  30:  	('&NumLogiciel','&NomLogiciel','&DateAchatLogiciel','&VersionLogiciel','&TypeLogiciel',0);
new  30:  	('log10','Rose98','15-MAY-1997','1.00','TX',0);
old  32: 	MESSAGE := 'Enregistrement du logiciel &NomLogiciel dans LOGICIEL';
new  32: 	MESSAGE := 'Enregistrement du logiciel Rose98 dans LOGICIEL';
old  36: 	WHERE N_SEGMENT='&NumSegment'
new  36: 	WHERE N_SEGMENT='130.120.82'
old  37: 	AND TYPE_P='&TypeLogiciel';
new  37: 	AND TYPE_P='TX';
old  46: 		(CURSEURPOSTE_REC.N_POSTE,'&NumLogiciel',SYSDATE);
new  46: 		(CURSEURPOSTE_REC.N_POSTE,'log10',SYSDATE);
old  49: 		UPDATE LOGICIEL SET NB_INSTALL = NB_INSTALL + 1 WHERE '&NumLogiciel' = N_LOG;
new  49: 		UPDATE LOGICIEL SET NB_INSTALL = NB_INSTALL + 1 WHERE 'log10' = N_LOG;
old  62: 		INSERT INTO COMPTE_RENDU VALUES ('Le &NumLogiciel est deja prsent dans LOGICIEL.');
new  62: 		INSERT INTO COMPTE_RENDU VALUES ('Le log10 est deja prsent dans LOGICIEL.');

PL/SQL procedure successfully completed.

No errors.

LIGNE_COMPTE_RENDU                                                              
--------------------------------------------------------------------------------
Aucune installation possible sur ce segment: pas de poste de ce type.           