-- trigger sur POSTE
CREATE OR REPLACE TRIGGER INSERT_POSTE
BEFORE
INSERT 
ON POSTE
FOR EACH ROW
DECLARE
	NO_DATA_FOUND EXCEPTION;
	NUMSEGMENT VARCHAR2(10);
	NOMBPOSTE  NUMBER(3);
BEGIN
	SELECT N_SEGMENT INTO NUMSEGMENT
	FROM SALLE
	WHERE N_SALLE = :NEW.N_SALLE;	
	IF (NUMSEGMENT!= :NEW.N_SEGMENT) THEN
		RAISE_APPLICATION_ERROR (-20103, 'SALLE NON TRAVERSEE PAR SEGMENT');
	END IF;
	
	SELECT NB_POSTE INTO NOMBPOSTE
	FROM SALLE
	WHERE N_SALLE = :NEW.N_SALLE;
	IF (NOMBPOSTE = 14) THEN
		RAISE_APPLICATION_ERROR (-20104,'MAXIMUM DE POSTES ATTEINT');
	END IF;

EXCEPTION
	WHEN NO_DATA_FOUND THEN
		ROLLBACK;	
	 		RAISE_APPLICATION_ERROR(+100 ,'DONNEE NON TROUVEE');
END;
